#include <stdio.h>
#include <stdlib.h>

#include "ring_buffer.h"

#define MAX 10

int main(int argc, char**argv)
   {
   int i, j;
   int *ip;
   struct ring_buffer * rb;
   void * p;
   
   rb = ring_buffer_new(MAX);
   if (NULL == rb)
      {
      perror("ring_buffer_new: ");
      exit(EXIT_FAILURE);
      }

   // Add 10 items
   for (i=0; i < MAX; i++)
      {
       ip = malloc(sizeof(int));
      *ip = i;
      p = ring_buffer_write(rb, (void *) ip);
      if ((p != NULL) && (p != ip))
         free(p);
      }

   // remove 5 items
   printf("ring_buffer size is %zd\n", ring_buffer_size(rb));
   for (j=0; j < 5 && NULL != (ip = ring_buffer_read(rb)); j++)
      {
      printf("%d\n", *ip);
      free(ip);
      }
   printf("ring_buffer size is %zd\n", ring_buffer_size(rb));

   // add 8 more items
   for (j = 0; j < MAX-2; j++, i++)
      {
       ip = malloc(sizeof(int));
      *ip = i;
      p = ring_buffer_write(rb, (void *) ip);
      if ((p != NULL) && (p != ip))
         free(p);
      }

   // remove all items
   printf("ring_buffer size is %zd\n", ring_buffer_size(rb));
   while (NULL != (ip = ring_buffer_read(rb)))
      {
      printf("%d\n", *ip);
      free(ip);
      }
   printf("ring_buffer size is %zd\n", ring_buffer_size(rb));

   ring_buffer_delete(rb);

   exit(EXIT_SUCCESS);
   }
